.TH cifsd 8
.SH NAME
cifsd \- CIFS/SMB network daemon
.SH SYNOPSIS
.B ip/cifsd
[
.B -t
] [
.B -d
] [
.B -f
.I debuglog
] [
.B -w
.I name
] [
.B -o
.I option
] ... [
.I conndir
]
.SH DESCRIPTION
.I Cifsd
exports filesystems to
.SM CIFS or
.SM SMB
clients like Microsoft \(tm Windows.
.PP
It is normally started by the network listen process via the
.B /rc/bin/service/tcp445
service script (see
.IR listen (8)),
wich passes
.I conndir
and filedescriptors 0 and 1 to the incoming connection.
.PP
Users are authenticated by ther Inferno/pop secret held by the auth server.
When successfull,
.I cifsd
changes its user id and namespace to the authenticated user.
Informative log messages are appended to
.B /sys/log/cifsd
if it exists.
.PP
By default the share 
.B local
is offered, which represents the root of the namespace
described by
.B /lib/namespace.
If a different name is explicitly requested by the client then
.B /bin/9fs
(see
.IR srv (4))
is invoked to attach that filesystem, which is then exported instead.
.PP
The flags are:
.TP
.B t
Run the server in trusted mode, so it will not require
authentication from the client and keep running in the callers
namespace.
.TP
.B d
Enable or increases debug verbosity for the
.I debuglog
file. Debug messages are never written to the system logfile.
.TP
.B f
Specify the filename for the
.I debuglog
file. If not specified no debug messages are generated.
.TP
.B w
Set the workgroup (or primary domain) to
.I name. The default is
.SM WORKGROUP
.TP
.B o
Enable one of the following options:
.RS
.B trspaces
transforms whitespaces in filenames to non breaking whitespaces. This is usefull
when exporting filesystems other than fossil.
.SH FILES
.B /rc/bin/service/tcp445
.br
.B /sys/log/cifsd
.br
.B /lib/namespace
.SH SOURCE
.B /sys/src/cmd/ip/cifsd
.SH "SEE ALSO"
.IR listen (8),
.IR srv (4)
.SH BUGS
.I Cifsd
grants clients exclusive oplocks even though it has no way to enforce
data consistency when dealing with concuring requests. This may cause
data corruption in some applications.
